diff --git a/MAINTAINERS b/MAINTAINERS
index dcac46003e..7a6972fe1a 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -433,6 +433,7 @@ Muxers/Demuxers:
   idroqdec.c                            Mike Melanson
   iff.c                                 Jaikrishnan Menon
   img2*.c                               Michael Niedermayer
+  imf*.c                                Marc-Antoine Arnaud, Pierre-Anthony Lemieux, Valentin Noël
   ipmovie.c                             Mike Melanson
   ircam*                                Paul B Mahol
   iss.c                                 Stefan Gehrer
diff --git a/configure b/configure
index c01aa480c7..56d4022010 100755
--- a/configure
+++ b/configure
@@ -297,7 +297,7 @@ External library support:
   --enable-libxvid         enable Xvid encoding via xvidcore,
                            native MPEG-4/Xvid encoder exists [no]
   --enable-libxml2         enable XML parsing using the C library libxml2, needed
-                           for dash demuxing support [no]
+                           for dash and imf demuxing support [no]
   --enable-libzimg         enable z.lib, needed for zscale filter [no]
   --enable-libzmq          enable message passing via libzmq [no]
   --enable-libzvbi         enable teletext support via libzvbi [no]
@@ -3374,6 +3374,7 @@ hls_muxer_select="mpegts_muxer"
 hls_muxer_suggest="gcrypt openssl"
 image2_alias_pix_demuxer_select="image2_demuxer"
 image2_brender_pix_demuxer_select="image2_demuxer"
+imf_demuxer_deps="libxml2"
 ipod_muxer_select="mov_muxer"
 ismv_muxer_select="mov_muxer"
 ivf_muxer_select="av1_metadata_bsf vp9_superframe_bsf"
diff --git a/doc/demuxers.texi b/doc/demuxers.texi
index 1c9575b2e8..37efe6ce1a 100644
--- a/doc/demuxers.texi
+++ b/doc/demuxers.texi
@@ -267,6 +267,12 @@ which streams to actually receive.
 Each stream mirrors the @code{id} and @code{bandwidth} properties from the
 @code{<Representation>} as metadata keys named "id" and "variant_bitrate" respectively.
 
+@section imf
+
+Interoperable Master Format demuxer.
+
+This demuxer presents audio and video streams found in an IMF Composition.
+
 @section flv, live_flv, kux
 
 Adobe Flash Video Format demuxer.
diff --git a/libavformat/Makefile b/libavformat/Makefile
index 3d6c8ef8f5..dda2bc9a47 100644
--- a/libavformat/Makefile
+++ b/libavformat/Makefile
@@ -285,6 +285,7 @@ OBJS-$(CONFIG_IMAGE_WEBP_PIPE_DEMUXER)    += img2dec.o img2.o
 OBJS-$(CONFIG_IMAGE_XBM_PIPE_DEMUXER)     += img2dec.o img2.o
 OBJS-$(CONFIG_IMAGE_XPM_PIPE_DEMUXER)     += img2dec.o img2.o
 OBJS-$(CONFIG_IMAGE_XWD_PIPE_DEMUXER)     += img2dec.o img2.o
+OBJS-$(CONFIG_IMF_DEMUXER)               += imfdec.o imf_cpl.o
 OBJS-$(CONFIG_INGENIENT_DEMUXER)         += ingenientdec.o rawdec.o
 OBJS-$(CONFIG_IPMOVIE_DEMUXER)           += ipmovie.o
 OBJS-$(CONFIG_IPU_DEMUXER)               += ipudec.o rawdec.o
@@ -694,6 +695,7 @@ TESTPROGS-$(CONFIG_FFRTMPCRYPT_PROTOCOL) += rtmpdh
 TESTPROGS-$(CONFIG_MOV_MUXER)            += movenc
 TESTPROGS-$(CONFIG_NETWORK)              += noproxy
 TESTPROGS-$(CONFIG_SRTP)                 += srtp
+TESTPROGS-$(CONFIG_IMF_DEMUXER)          += imf
 
 TOOLS     = aviocat                                                     \
             ismindex                                                    \
diff --git a/libavformat/allformats.c b/libavformat/allformats.c
index cbfadcb639..91cd9a4c73 100644
--- a/libavformat/allformats.c
+++ b/libavformat/allformats.c
@@ -212,6 +212,7 @@ extern const AVInputFormat  ff_image2pipe_demuxer;
 extern const AVOutputFormat ff_image2pipe_muxer;
 extern const AVInputFormat  ff_image2_alias_pix_demuxer;
 extern const AVInputFormat  ff_image2_brender_pix_demuxer;
+extern const AVInputFormat  ff_imf_demuxer;
 extern const AVInputFormat  ff_ingenient_demuxer;
 extern const AVInputFormat  ff_ipmovie_demuxer;
 extern const AVOutputFormat ff_ipod_muxer;
diff --git a/libavformat/imf.h b/libavformat/imf.h
new file mode 100644
index 0000000000..59283a5d3a
--- /dev/null
+++ b/libavformat/imf.h
@@ -0,0 +1,197 @@
+/*
+ * Copyright (c) Sandflow Consulting LLC
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * * Redistributions of source code must retain the above copyright notice, this
+ *   list of conditions and the following disclaimer.
+ * * Redistributions in binary form must reproduce the above copyright notice,
+ *   this list of conditions and the following disclaimer in the documentation
+ *   and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+ * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+/**
+ * Public header file for the processing of Interoperable Master Format (IMF) packages.
+ * 
+ * @author Pierre-Anthony Lemieux
+ * @author Valentin Noel
+ * @file
+ * @ingroup lavu_imf
+ */
+
+#ifndef AVFORMAT_IMF_H
+#define AVFORMAT_IMF_H
+
+#include "avformat.h"
+#include "libavformat/avio.h"
+#include "libavutil/rational.h"
+#include <libxml/tree.h>
+
+#define IMF_UUID_FORMAT "urn:uuid:%02hhx%02hhx%02hhx%02hhx-%02hhx%02hhx-%02hhx%02hhx-%02hhx%02hhx-%02hhx%02hhx%02hhx%02hhx%02hhx%02hhx"
+
+/**
+ * UUID as defined in IETF RFC 422
+ */
+typedef uint8_t UUID[16];
+
+/**
+ * IMF Composition Playlist Base Resource
+ */
+typedef struct IMFBaseResource {
+    AVRational edit_rate; /**< BaseResourceType/EditRate */
+    unsigned long entry_point; /**< BaseResourceType/EntryPoint */
+    unsigned long duration; /**< BaseResourceType/Duration */
+    unsigned long repeat_count; /**< BaseResourceType/RepeatCount */
+} IMFBaseResource;
+
+/**
+ * IMF Composition Playlist Track File Resource
+ */
+typedef struct IMFTrackFileResource {
+    IMFBaseResource base;
+    UUID track_file_uuid; /**< TrackFileResourceType/TrackFileId */
+} IMFTrackFileResource;
+
+/**
+ * IMF Marker
+ */
+typedef struct IMFMarker {
+    xmlChar *label_utf8; /**< Marker/Label */
+    xmlChar *scope_utf8; /**< Marker/Label/\@scope */
+    unsigned long offset; /**< Marker/Offset */
+} IMFMarker;
+
+/**
+ * IMF Composition Playlist Marker Resource
+ */
+typedef struct IMFMarkerResource {
+    IMFBaseResource base;
+    unsigned long marker_count; /**< Number of Marker elements */
+    IMFMarker *markers; /**< Marker elements */
+} IMFMarkerResource;
+
+/**
+ * IMF Composition Playlist Virtual Track
+ */
+typedef struct IMFBaseVirtualTrack {
+    UUID id_uuid; /**< TrackId associated with the Virtual Track */
+} IMFBaseVirtualTrack;
+
+/**
+ * IMF Composition Playlist Virtual Track that consists of Track File Resources
+ */
+typedef struct IMFTrackFileVirtualTrack {
+    IMFBaseVirtualTrack base;
+    unsigned long resource_count; /**< Number of Resource elements present in the Virtual Track */
+    IMFTrackFileResource *resources; /**< Resource elements of the Virtual Track */
+} IMFTrackFileVirtualTrack;
+
+/**
+ * IMF Composition Playlist Virtual Track that consists of Marker Resources
+ */
+typedef struct IMFMarkerVirtualTrack {
+    IMFBaseVirtualTrack base;
+    unsigned long resource_count; /**< Number of Resource elements present in the Virtual Track */
+    IMFMarkerResource *resources; /**< Resource elements of the Virtual Track */
+} IMFMarkerVirtualTrack;
+
+/**
+ * IMF Composition Playlist
+ */
+typedef struct IMFCPL {
+    UUID id_uuid; /**< CompositionPlaylist/Id element */
+    xmlChar *content_title_utf8; /**< CompositionPlaylist/ContentTitle element */
+    AVRational edit_rate; /**< CompositionPlaylist/EditRate element */
+    IMFMarkerVirtualTrack *main_markers_track; /**< Main Marker Virtual Track */
+    IMFTrackFileVirtualTrack *main_image_2d_track; /**< Main Image Virtual Track */
+    unsigned long main_audio_track_count; /**< Number of Main Audio Virtual Tracks */
+    IMFTrackFileVirtualTrack *main_audio_tracks; /**< Main Audio Virtual Tracks */
+} IMFCPL;
+
+/**
+ * Parse an IMF CompositionPlaylist element into the IMFCPL data structure.
+ * @param[in] doc An XML document from which the CPL is read.
+ * @param[out] cpl Pointer to a memory area (allocated by the client), where the function writes a pointer to the newly constructed
+ * IMFCPL structure (or NULL if the CPL could not be parsed). The client is responsible for freeing the IMFCPL structure using
+ * imf_cpl_free().
+ * @return A non-zero value in case of an error.
+ */
+int parse_imf_cpl_from_xml_dom(xmlDocPtr doc, IMFCPL **cpl);
+
+/**
+ * Parse an IMF Composition Playlist document into the IMFCPL data structure.
+ * @param[in] in The context from which the CPL is read.
+ * @param[out] cpl Pointer to a memory area (allocated by the client), where the function writes a pointer to the newly constructed
+ * IMFCPL structure (or NULL if the CPL could not be parsed). The client is responsible for freeing the IMFCPL structure using
+ * imf_cpl_free().
+ * @return A non-zero value in case of an error.
+ */
+int parse_imf_cpl(AVIOContext *in, IMFCPL **cpl);
+
+/**
+ * Allocates and initializes an IMFCPL data structure.
+ * @return A pointer to the newly constructed IMFCPL structure (or NULL if the structure could not be constructed). The client is
+ * responsible for freeing the IMFCPL structure using imf_cpl_free().
+ */
+IMFCPL *imf_cpl_alloc(void);
+
+/**
+ * Deletes an IMFCPL data structure previously instantiated with imf_cpl_alloc().
+ * @param[in] cpl The IMFCPL structure to delete.
+ */
+void imf_cpl_free(IMFCPL *cpl);
+
+/**
+ * Reads an unsigned long from an XML element
+ * @return 0 on success, < 0 AVERROR code on error.
+ */
+int imf_xml_read_ulong(xmlNodePtr element, unsigned long *number);
+
+/**
+ * Reads an AVRational from an XML element
+ * @return 0 on success, < 0 AVERROR code on error.
+ */
+int imf_xml_read_rational(xmlNodePtr element, AVRational *rational);
+
+/**
+ * Reads a UUID from an XML element
+ * @return 0 on success, < 0 AVERROR code on error.
+ */
+int imf_xml_read_UUID(xmlNodePtr element, uint8_t uuid[16]);
+
+/**
+ * Returns the first child element with the specified local name
+ * @return A pointer to the child element, or NULL if no such child element exists.
+ */
+xmlNodePtr imf_xml_get_child_element_by_name(xmlNodePtr parent, const char *name_utf8);
+
+#endif